<html>
<head>
<title>OGRE: OgreSIMDHelper.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_96a9708cfab29525519b2d4762aad636.html">src</a></div>
<h1>OgreSIMDHelper.h</h1><a href="OgreSIMDHelper_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __SIMDHelper_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __SIMDHelper_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePlatformInformation_8h.html">OgrePlatformInformation.h</a>"</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Stack-alignment hackery.</span>
<a name="l00036"></a>00036 <span class="comment">//</span>
<a name="l00037"></a>00037 <span class="comment">// If macro __OGRE_SIMD_ALIGN_STACK defined, means there requests</span>
<a name="l00038"></a>00038 <span class="comment">// special code to ensure stack align to a 16-bytes boundary.</span>
<a name="l00039"></a>00039 <span class="comment">//</span>
<a name="l00040"></a>00040 <span class="comment">// Note:</span>
<a name="l00041"></a>00041 <span class="comment">//   This macro can only guarantee callee stack pointer (esp) align</span>
<a name="l00042"></a>00042 <span class="comment">// to a 16-bytes boundary, but not that for frame pointer (ebp).</span>
<a name="l00043"></a>00043 <span class="comment">// Because most compiler might use frame pointer to access to stack</span>
<a name="l00044"></a>00044 <span class="comment">// variables, so you need to wrap those alignment required functions</span>
<a name="l00045"></a>00045 <span class="comment">// with extra function call.</span>
<a name="l00046"></a>00046 <span class="comment">//</span>
<a name="l00047"></a>00047 <span class="preprocessor">#if defined(__INTEL_COMPILER)</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="comment">// For intel's compiler, simply calling alloca seems to do the right</span>
<a name="l00049"></a>00049 <span class="comment">// thing. The size of the allocated block seems to be irrelevant.</span>
<a name="l00050"></a>00050 <span class="preprocessor">#define __OGRE_SIMD_ALIGN_STACK()   _alloca(16)</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span>
<a name="l00052"></a>00052 <span class="preprocessor">#elif OGRE_CPU == OGRE_CPU_X86 &amp;&amp; OGRE_COMPILER == OGRE_COMPILER_GNUC</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="comment">//</span>
<a name="l00054"></a>00054 <span class="comment">// Horrible hack to align the stack to a 16-bytes boundary for gcc.</span>
<a name="l00055"></a>00055 <span class="comment">//</span>
<a name="l00056"></a>00056 <span class="comment">// We assume a gcc version &gt;= 2.95 so that</span>
<a name="l00057"></a>00057 <span class="comment">// -mpreferred-stack-boundary works.  Otherwise, all bets are</span>
<a name="l00058"></a>00058 <span class="comment">// off.  However, -mpreferred-stack-boundary does not create a</span>
<a name="l00059"></a>00059 <span class="comment">// stack alignment, but it only preserves it.  Unfortunately,</span>
<a name="l00060"></a>00060 <span class="comment">// since Ogre are designed as a flexibility library, user might</span>
<a name="l00061"></a>00061 <span class="comment">// compile their application with wrong stack alignment, even</span>
<a name="l00062"></a>00062 <span class="comment">// if user taken care with stack alignment, but many versions</span>
<a name="l00063"></a>00063 <span class="comment">// of libc on linux call main() with the wrong initial stack</span>
<a name="l00064"></a>00064 <span class="comment">// alignment the result that the code is now pessimally aligned</span>
<a name="l00065"></a>00065 <span class="comment">// instead of having a 50% chance of being correct.</span>
<a name="l00066"></a>00066 <span class="comment">//</span>
<a name="l00067"></a><a class="code" href="OgreSIMDHelper_8h.html#751b240bcf7b34507a4e9306be08a0e4">00067</a> <span class="preprocessor">#define __OGRE_SIMD_ALIGN_STACK()                                   \</span>
<a name="l00068"></a>00068 <span class="preprocessor">    {                                                               \</span>
<a name="l00069"></a>00069 <span class="preprocessor">        </span><span class="comment">/* Use alloca to allocate some memory on the stack.  */</span>     \
<a name="l00070"></a>00070         <span class="comment">/* This alerts gcc that something funny is going on, */</span>     \
<a name="l00071"></a>00071         <span class="comment">/* so that it does not omit the frame pointer etc.   */</span>     \
<a name="l00072"></a>00072         (void)__builtin_alloca(16);                                 \
<a name="l00073"></a>00073         <span class="comment">/* Now align the stack pointer */</span>                           \
<a name="l00074"></a>00074         __asm__ __volatile__ ("andl $-16, %esp");                   \
<a name="l00075"></a>00075     }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="preprocessor">#elif defined(_MSC_VER)</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span><span class="comment">// Fortunately, MSVC will align the stack automatically</span>
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="preprocessor">#endif</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span>
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="comment">// Additional platform-dependent header files and declares.</span>
<a name="l00084"></a>00084 <span class="comment">//</span>
<a name="l00085"></a>00085 <span class="comment">// NOTE: Should be sync with __OGRE_HAVE_SSE macro.</span>
<a name="l00086"></a>00086 <span class="comment">//</span>
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="preprocessor">#if OGRE_DOUBLE_PRECISION == 0 &amp;&amp; OGRE_CPU == OGRE_CPU_X86</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span>
<a name="l00090"></a>00090 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_MSVC || defined(__INTEL_COMPILER)</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span><span class="preprocessor">#include "<a class="code" href="OgreNoMemoryMacros_8h.html">OgreNoMemoryMacros.h</a>"</span>
<a name="l00092"></a>00092 <span class="preprocessor">#include &lt;xmmintrin.h&gt;</span>
<a name="l00093"></a>00093 <span class="preprocessor">#include "<a class="code" href="OgreMemoryMacros_8h.html">OgreMemoryMacros.h</a>"</span>
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="preprocessor">#elif OGRE_COMPILER == OGRE_COMPILER_GNUC</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span><span class="comment">// Don't define ourself version SSE intrinsics if "xmmintrin.h" already included.</span>
<a name="l00097"></a>00097 <span class="comment">//</span>
<a name="l00098"></a>00098 <span class="comment">// Note: gcc in some platform already included "xmmintrin.h" for some reason.</span>
<a name="l00099"></a>00099 <span class="comment">// I pick up macro _XMMINTRIN_H_INCLUDED here which based on the "xmmintrin.h"</span>
<a name="l00100"></a>00100 <span class="comment">// comes with cygwin gcc 3.4.4, guess it should be solved duplicate definition</span>
<a name="l00101"></a>00101 <span class="comment">// problem on gcc for x86.</span>
<a name="l00102"></a>00102 <span class="comment">//</span>
<a name="l00103"></a>00103 <span class="preprocessor">#if !defined(_XMMINTRIN_H_INCLUDED)</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span>
<a name="l00105"></a>00105 <span class="comment">// Simulate VC/ICC intrinsics. Only used intrinsics are declared here.</span>
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="keyword">typedef</span> <span class="keywordtype">float</span> __m128 __attribute__ ((mode(V4SF),aligned(16)));
<a name="l00108"></a>00108 <span class="keyword">typedef</span> <span class="keywordtype">int</span> __m64 __attribute__ ((mode(V2SI)));
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="comment">// Macro for declare intrinsic routines always inline even if in debug build</span>
<a name="l00111"></a>00111 <span class="preprocessor">#define __ALWAYS_INLINE    FORCEINLINE __attribute__ ((__always_inline__))</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>
<a name="l00113"></a>00113 <span class="comment">// Shuffle instruction must be declare as macro</span>
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="preprocessor">#define _MM_SHUFFLE(fp3,fp2,fp1,fp0) \</span>
<a name="l00116"></a>00116 <span class="preprocessor">    (((fp3) &lt;&lt; 6) | ((fp2) &lt;&lt; 4) | ((fp1) &lt;&lt; 2) | ((fp0)))</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>
<a name="l00118"></a>00118 <span class="preprocessor">#define _mm_shuffle_ps(a, b, imm8) __extension__                                        \</span>
<a name="l00119"></a>00119 <span class="preprocessor">    ({                                                                                  \</span>
<a name="l00120"></a>00120 <span class="preprocessor">        __m128 result;                                                                  \</span>
<a name="l00121"></a>00121 <span class="preprocessor">        __asm__("shufps %3, %2, %0" : "=x" (result) : "0" (a), "xm" (b), "N" (imm8));   \</span>
<a name="l00122"></a>00122 <span class="preprocessor">        result;                                                                         \</span>
<a name="l00123"></a>00123 <span class="preprocessor">    })</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span>
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="comment">// Load/store instructions</span>
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="preprocessor">#define __MM_DECL_LD(name, instruction, type)                               \</span>
<a name="l00129"></a>00129 <span class="preprocessor">    static __ALWAYS_INLINE __m128 _mm_##name(const type *addr)              \</span>
<a name="l00130"></a>00130 <span class="preprocessor">    {                                                                       \</span>
<a name="l00131"></a>00131 <span class="preprocessor">        __m128 result;                                                      \</span>
<a name="l00132"></a>00132 <span class="preprocessor">        __asm__( #instruction " %1, %0" : "=x" (result) : "m" (*addr));     \</span>
<a name="l00133"></a>00133 <span class="preprocessor">        return result;                                                      \</span>
<a name="l00134"></a>00134 <span class="preprocessor">    }</span>
<a name="l00135"></a>00135 <span class="preprocessor"></span>
<a name="l00136"></a>00136 <span class="preprocessor">#define __MM_DECL_LD2(name, instruction, type)                                      \</span>
<a name="l00137"></a>00137 <span class="preprocessor">    static __ALWAYS_INLINE __m128 _mm_##name(__m128 val, const type *addr)          \</span>
<a name="l00138"></a>00138 <span class="preprocessor">    {                                                                               \</span>
<a name="l00139"></a>00139 <span class="preprocessor">        __m128 result;                                                              \</span>
<a name="l00140"></a>00140 <span class="preprocessor">        __asm__( #instruction " %2, %0" : "=x" (result) : "0"(val), "m" (*addr));   \</span>
<a name="l00141"></a>00141 <span class="preprocessor">        return result;                                                              \</span>
<a name="l00142"></a>00142 <span class="preprocessor">    }</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span>
<a name="l00144"></a>00144 <span class="preprocessor">#define __MM_DECL_ST(name, instruction, type)                               \</span>
<a name="l00145"></a>00145 <span class="preprocessor">    static __ALWAYS_INLINE void _mm_##name(type *addr, __m128 val)          \</span>
<a name="l00146"></a>00146 <span class="preprocessor">    {                                                                       \</span>
<a name="l00147"></a>00147 <span class="preprocessor">        __asm__( #instruction " %1, %0" : "=m" (*addr) : "x" (val));        \</span>
<a name="l00148"></a>00148 <span class="preprocessor">    }</span>
<a name="l00149"></a>00149 <span class="preprocessor"></span>
<a name="l00150"></a>00150 __MM_DECL_LD(loadu_ps, movups, <span class="keywordtype">float</span>)
<a name="l00151"></a>00151 __MM_DECL_ST(storeu_ps, movups, <span class="keywordtype">float</span>)
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 __MM_DECL_LD(load_ss, movss, <span class="keywordtype">float</span>)
<a name="l00154"></a>00154 __MM_DECL_ST(store_ss, movss, <span class="keywordtype">float</span>)
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 __MM_DECL_ST(storel_pi, movlps, __m64)
<a name="l00157"></a>00157 __MM_DECL_ST(storeh_pi, movhps, __m64)
<a name="l00158"></a>00158 __MM_DECL_LD2(loadl_pi, movlps, __m64)
<a name="l00159"></a>00159 __MM_DECL_LD2(loadh_pi, movhps, __m64)
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="preprocessor">#undef __MM_DECL_LD</span>
<a name="l00162"></a>00162 <span class="preprocessor"></span><span class="preprocessor">#undef __MM_DECL_LD2</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span><span class="preprocessor">#undef __MM_DECL_ST</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>
<a name="l00165"></a>00165 <span class="comment">// Two operand instructions</span>
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="preprocessor">#define __MM_DECL_OP2(name, instruction, constraint)                                    \</span>
<a name="l00168"></a>00168 <span class="preprocessor">    static __ALWAYS_INLINE __m128 _mm_##name(__m128 a, __m128 b)                        \</span>
<a name="l00169"></a>00169 <span class="preprocessor">    {                                                                                   \</span>
<a name="l00170"></a>00170 <span class="preprocessor">        __m128 result;                                                                  \</span>
<a name="l00171"></a>00171 <span class="preprocessor">        __asm__( #instruction " %2, %0" : "=x" (result) : "0" (a), #constraint (b));    \</span>
<a name="l00172"></a>00172 <span class="preprocessor">        return result;                                                                  \</span>
<a name="l00173"></a>00173 <span class="preprocessor">    }</span>
<a name="l00174"></a>00174 <span class="preprocessor"></span>
<a name="l00175"></a>00175 __MM_DECL_OP2(add_ps, addps, xm)
<a name="l00176"></a>00176 __MM_DECL_OP2(add_ss, addss, xm)
<a name="l00177"></a>00177 __MM_DECL_OP2(sub_ps, subps, xm)
<a name="l00178"></a>00178 __MM_DECL_OP2(sub_ss, subss, xm)
<a name="l00179"></a>00179 __MM_DECL_OP2(mul_ps, mulps, xm)
<a name="l00180"></a>00180 __MM_DECL_OP2(mul_ss, mulss, xm)
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 __MM_DECL_OP2(xor_ps, xorps, xm)
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 __MM_DECL_OP2(unpacklo_ps, unpcklps, xm)
<a name="l00185"></a>00185 __MM_DECL_OP2(unpackhi_ps, unpckhps, xm)
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 __MM_DECL_OP2(movehl_ps, movhlps, x)
<a name="l00188"></a>00188 __MM_DECL_OP2(movelh_ps, movlhps, x)
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 __MM_DECL_OP2(cmpnle_ps, cmpnleps, xm)
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 <span class="preprocessor">#undef __MM_DECL_OP2</span>
<a name="l00193"></a>00193 <span class="preprocessor"></span>
<a name="l00194"></a>00194 <span class="comment">// Other used instructions</span>
<a name="l00195"></a>00195 
<a name="l00196"></a>00196     <span class="keyword">static</span> __ALWAYS_INLINE __m128 _mm_load_ps1(<span class="keyword">const</span> <span class="keywordtype">float</span> *addr)
<a name="l00197"></a>00197     {
<a name="l00198"></a>00198         __m128 tmp = _mm_load_ss(addr);
<a name="l00199"></a>00199         <span class="keywordflow">return</span> _mm_shuffle_ps(tmp, tmp, 0);
<a name="l00200"></a>00200     }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202     <span class="keyword">static</span> __ALWAYS_INLINE __m128 _mm_setzero_ps(<span class="keywordtype">void</span>)
<a name="l00203"></a>00203     {
<a name="l00204"></a>00204         __m128 result;
<a name="l00205"></a>00205         __asm__(<span class="stringliteral">"xorps %0, %0"</span> : <span class="stringliteral">"=x"</span> (result));
<a name="l00206"></a>00206         <span class="keywordflow">return</span> result;
<a name="l00207"></a>00207     }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209     <span class="keyword">static</span> __ALWAYS_INLINE __m128 _mm_rsqrt_ps(__m128 val)
<a name="l00210"></a>00210     {
<a name="l00211"></a>00211         __m128 result;
<a name="l00212"></a>00212         __asm__(<span class="stringliteral">"rsqrtps %1, %0"</span> : <span class="stringliteral">"=x"</span> (result) : <span class="stringliteral">"xm"</span> (val));
<a name="l00213"></a>00213         <span class="comment">//__asm__("rsqrtps %0, %0" : "=x" (result) : "0" (val));</span>
<a name="l00214"></a>00214         <span class="keywordflow">return</span> result;
<a name="l00215"></a>00215     }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217     <span class="keyword">static</span> __ALWAYS_INLINE <span class="keywordtype">int</span> _mm_movemask_ps(__m128 val)
<a name="l00218"></a>00218     {
<a name="l00219"></a>00219         <span class="keywordtype">int</span> result;
<a name="l00220"></a>00220         __asm__(<span class="stringliteral">"movmskps %1, %0"</span> : <span class="stringliteral">"=r"</span> (result) : <span class="stringliteral">"x"</span> (val));
<a name="l00221"></a>00221         <span class="keywordflow">return</span> result;
<a name="l00222"></a>00222     }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 <span class="preprocessor">#endif // !defined(_XMMINTRIN_H_INCLUDED)</span>
<a name="l00225"></a>00225 <span class="preprocessor"></span>
<a name="l00226"></a>00226 <span class="preprocessor">#endif // OGRE_COMPILER == OGRE_COMPILER_GNUC</span>
<a name="l00227"></a>00227 <span class="preprocessor"></span>
<a name="l00228"></a>00228 <span class="preprocessor">#endif // OGRE_DOUBLE_PRECISION == 0 &amp;&amp; OGRE_CPU == OGRE_CPU_X86</span>
<a name="l00229"></a>00229 <span class="preprocessor"></span>
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00233"></a>00233 <span class="comment">// SIMD macros and helpers</span>
<a name="l00234"></a>00234 <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 <span class="keyword">namespace </span>Ogre {
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 <span class="preprocessor">#if __OGRE_HAVE_SSE</span>
<a name="l00240"></a>00240 <span class="preprocessor"></span>
<a name="l00251"></a>00251 <span class="preprocessor">#if 1</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span><span class="preprocessor">#define __MM_RSQRT_PS(x)    _mm_rsqrt_ps(x)</span>
<a name="l00253"></a>00253 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span><span class="preprocessor">#define __MM_RSQRT_PS(x)    __mm_rsqrt_nr_ps(x) // Implemented below</span>
<a name="l00255"></a>00255 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>
<a name="l00265"></a>00265 <span class="preprocessor">#define __MM_TRANSPOSE4x4_PS(r0, r1, r2, r3)                                        \</span>
<a name="l00266"></a>00266 <span class="preprocessor">    {                                                                               \</span>
<a name="l00267"></a>00267 <span class="preprocessor">        __m128 t3, t2, t1, t0;                                                      \</span>
<a name="l00268"></a>00268 <span class="preprocessor">                                                                                    \</span>
<a name="l00269"></a>00269 <span class="preprocessor">                                                            </span><span class="comment">/* r00 r01 r02 r03 */</span>   \
<a name="l00270"></a>00270                                                             <span class="comment">/* r10 r11 r12 r13 */</span>   \
<a name="l00271"></a>00271                                                             <span class="comment">/* r20 r21 r22 r23 */</span>   \
<a name="l00272"></a>00272                                                             <span class="comment">/* r30 r31 r32 r33 */</span>   \
<a name="l00273"></a>00273                                                                                     \
<a name="l00274"></a>00274         t0 = _mm_unpacklo_ps(r0, r1);                       <span class="comment">/* r00 r10 r01 r11 */</span>   \
<a name="l00275"></a>00275         t2 = _mm_unpackhi_ps(r0, r1);                       <span class="comment">/* r02 r12 r03 r13 */</span>   \
<a name="l00276"></a>00276         t1 = _mm_unpacklo_ps(r2, r3);                       <span class="comment">/* r20 r30 r21 r31 */</span>   \
<a name="l00277"></a>00277         t3 = _mm_unpackhi_ps(r2, r3);                       <span class="comment">/* r22 r32 r23 r33 */</span>   \
<a name="l00278"></a>00278                                                                                     \
<a name="l00279"></a>00279         r0 = _mm_movelh_ps(t0, t1);                         <span class="comment">/* r00 r10 r20 r30 */</span>   \
<a name="l00280"></a>00280         r1 = _mm_movehl_ps(t1, t0);                         <span class="comment">/* r01 r11 r21 r31 */</span>   \
<a name="l00281"></a>00281         r2 = _mm_movelh_ps(t2, t3);                         <span class="comment">/* r02 r12 r22 r32 */</span>   \
<a name="l00282"></a>00282         r3 = _mm_movehl_ps(t3, t2);                         <span class="comment">/* r03 r13 r23 r33 */</span>   \
<a name="l00283"></a>00283     }
<a name="l00284"></a>00284 
<a name="l00293"></a>00293 <span class="preprocessor">#define __MM_TRANSPOSE4x3_PS(v0, v1, v2)                                            \</span>
<a name="l00294"></a>00294 <span class="preprocessor">    {                                                                               \</span>
<a name="l00295"></a>00295 <span class="preprocessor">        __m128 t0, t1, t2;                                                          \</span>
<a name="l00296"></a>00296 <span class="preprocessor">                                                                                    \</span>
<a name="l00297"></a>00297 <span class="preprocessor">                                                            </span><span class="comment">/* r00 r01 r02 r10 */</span>   \
<a name="l00298"></a>00298                                                             <span class="comment">/* r11 r12 r20 r21 */</span>   \
<a name="l00299"></a>00299                                                             <span class="comment">/* r22 r30 r31 r32 */</span>   \
<a name="l00300"></a>00300                                                                                     \
<a name="l00301"></a>00301         t0 = _mm_shuffle_ps(v0, v2, _MM_SHUFFLE(3,0,3,0));  <span class="comment">/* r00 r10 r22 r32 */</span>   \
<a name="l00302"></a>00302         t1 = _mm_shuffle_ps(v0, v1, _MM_SHUFFLE(1,0,2,1));  <span class="comment">/* r01 r02 r11 r12 */</span>   \
<a name="l00303"></a>00303         t2 = _mm_shuffle_ps(v1, v2, _MM_SHUFFLE(2,1,3,2));  <span class="comment">/* r20 r21 r30 r31 */</span>   \
<a name="l00304"></a>00304                                                                                     \
<a name="l00305"></a>00305         v0 = _mm_shuffle_ps(t0, t2, _MM_SHUFFLE(2,0,1,0));  <span class="comment">/* r00 r10 r20 r30 */</span>   \
<a name="l00306"></a>00306         v1 = _mm_shuffle_ps(t1, t2, _MM_SHUFFLE(3,1,2,0));  <span class="comment">/* r01 r11 r21 r31 */</span>   \
<a name="l00307"></a>00307         v2 = _mm_shuffle_ps(t1, t0, _MM_SHUFFLE(3,2,3,1));  <span class="comment">/* r02 r12 r22 r32 */</span>   \
<a name="l00308"></a>00308     }
<a name="l00309"></a>00309 
<a name="l00317"></a>00317 <span class="preprocessor">#define __MM_TRANSPOSE3x4_PS(v0, v1, v2)                                            \</span>
<a name="l00318"></a>00318 <span class="preprocessor">    {                                                                               \</span>
<a name="l00319"></a>00319 <span class="preprocessor">        __m128 t0, t1, t2;                                                          \</span>
<a name="l00320"></a>00320 <span class="preprocessor">                                                                                    \</span>
<a name="l00321"></a>00321 <span class="preprocessor">                                                            </span><span class="comment">/* r00 r10 r20 r30 */</span>   \
<a name="l00322"></a>00322                                                             <span class="comment">/* r01 r11 r21 r31 */</span>   \
<a name="l00323"></a>00323                                                             <span class="comment">/* r02 r12 r22 r32 */</span>   \
<a name="l00324"></a>00324                                                                                     \
<a name="l00325"></a>00325         t0 = _mm_shuffle_ps(v0, v2, _MM_SHUFFLE(2,0,3,1));  <span class="comment">/* r10 r30 r02 r22 */</span>   \
<a name="l00326"></a>00326         t1 = _mm_shuffle_ps(v1, v2, _MM_SHUFFLE(3,1,3,1));  <span class="comment">/* r11 r31 r12 r32 */</span>   \
<a name="l00327"></a>00327         t2 = _mm_shuffle_ps(v0, v1, _MM_SHUFFLE(2,0,2,0));  <span class="comment">/* r00 r20 r01 r21 */</span>   \
<a name="l00328"></a>00328                                                                                     \
<a name="l00329"></a>00329         v0 = _mm_shuffle_ps(t2, t0, _MM_SHUFFLE(0,2,2,0));  <span class="comment">/* r00 r01 r02 r10 */</span>   \
<a name="l00330"></a>00330         v1 = _mm_shuffle_ps(t1, t2, _MM_SHUFFLE(3,1,2,0));  <span class="comment">/* r11 r12 r20 r21 */</span>   \
<a name="l00331"></a>00331         v2 = _mm_shuffle_ps(t0, t1, _MM_SHUFFLE(3,1,1,3));  <span class="comment">/* r22 r30 r31 r32 */</span>   \
<a name="l00332"></a>00332     }
<a name="l00333"></a>00333 
<a name="l00337"></a>00337 <span class="preprocessor">#define __MM_SELECT(v, fp)                                                          \</span>
<a name="l00338"></a>00338 <span class="preprocessor">    _mm_shuffle_ps((v), (v), _MM_SHUFFLE((fp),(fp),(fp),(fp)))</span>
<a name="l00339"></a>00339 <span class="preprocessor"></span>
<a name="l00341"></a>00341 <span class="preprocessor">#define __MM_ACCUM4_PS(a, b, c, d)                                                  \</span>
<a name="l00342"></a>00342 <span class="preprocessor">    _mm_add_ps(_mm_add_ps(a, b), _mm_add_ps(c, d))</span>
<a name="l00343"></a>00343 <span class="preprocessor"></span>
<a name="l00347"></a>00347 <span class="preprocessor">#define __MM_DOT4x4_PS(a0, a1, a2, a3, b0, b1, b2, b3)                              \</span>
<a name="l00348"></a>00348 <span class="preprocessor">    __MM_ACCUM4_PS(_mm_mul_ps(a0, b0), _mm_mul_ps(a1, b1), _mm_mul_ps(a2, b2), _mm_mul_ps(a3, b3))</span>
<a name="l00349"></a>00349 <span class="preprocessor"></span>
<a name="l00353"></a>00353 <span class="preprocessor">#define __MM_DOT4x3_PS(r0, r1, r2, r3, v0, v1, v2)                                  \</span>
<a name="l00354"></a>00354 <span class="preprocessor">    __MM_ACCUM4_PS(_mm_mul_ps(r0, v0), _mm_mul_ps(r1, v1), _mm_mul_ps(r2, v2), r3)</span>
<a name="l00355"></a>00355 <span class="preprocessor"></span>
<a name="l00357"></a>00357 <span class="preprocessor">#define __MM_ACCUM3_PS(a, b, c)                                                     \</span>
<a name="l00358"></a>00358 <span class="preprocessor">    _mm_add_ps(_mm_add_ps(a, b), c)</span>
<a name="l00359"></a>00359 <span class="preprocessor"></span>
<a name="l00363"></a>00363 <span class="preprocessor">#define __MM_DOT3x3_PS(r0, r1, r2, v0, v1, v2)                                      \</span>
<a name="l00364"></a>00364 <span class="preprocessor">    __MM_ACCUM3_PS(_mm_mul_ps(r0, v0), _mm_mul_ps(r1, v1), _mm_mul_ps(r2, v2))</span>
<a name="l00365"></a>00365 <span class="preprocessor"></span>
<a name="l00367"></a>00367 <span class="preprocessor">#define __MM_MADD_PS(a, b, c)                                                       \</span>
<a name="l00368"></a>00368 <span class="preprocessor">    _mm_add_ps(_mm_mul_ps(a, b), c)</span>
<a name="l00369"></a>00369 <span class="preprocessor"></span>
<a name="l00371"></a>00371 <span class="preprocessor">#define __MM_LERP_PS(t, a, b)                                                       \</span>
<a name="l00372"></a>00372 <span class="preprocessor">    __MM_MADD_PS(_mm_sub_ps(b, a), t, a)</span>
<a name="l00373"></a>00373 <span class="preprocessor"></span>
<a name="l00375"></a>00375 <span class="preprocessor">#define __MM_MADD_SS(a, b, c)                                                       \</span>
<a name="l00376"></a>00376 <span class="preprocessor">    _mm_add_ss(_mm_mul_ss(a, b), c)</span>
<a name="l00377"></a>00377 <span class="preprocessor"></span>
<a name="l00379"></a>00379 <span class="preprocessor">#define __MM_LERP_SS(t, a, b)                                                       \</span>
<a name="l00380"></a>00380 <span class="preprocessor">    __MM_MADD_SS(_mm_sub_ss(b, a), t, a)</span>
<a name="l00381"></a>00381 <span class="preprocessor"></span>
<a name="l00383"></a>00383 <span class="preprocessor">#define __MM_LOAD_PS(p)                                                             \</span>
<a name="l00384"></a>00384 <span class="preprocessor">    (*(__m128*)(p))</span>
<a name="l00385"></a>00385 <span class="preprocessor"></span>
<a name="l00387"></a>00387 <span class="preprocessor">#define __MM_STORE_PS(p, v)                                                         \</span>
<a name="l00388"></a>00388 <span class="preprocessor">    (*(__m128*)(p) = (v))</span>
<a name="l00389"></a>00389 <span class="preprocessor"></span>
<a name="l00390"></a>00390 
<a name="l00393"></a>00393     <span class="keyword">template</span> &lt;<span class="keywordtype">bool</span> aligned = false&gt;
<a name="l00394"></a>00394     <span class="keyword">struct </span>SSEMemoryAccessor
<a name="l00395"></a>00395     {
<a name="l00396"></a>00396         <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> __m128 load(<span class="keyword">const</span> <span class="keywordtype">float</span> *p)
<a name="l00397"></a>00397         {
<a name="l00398"></a>00398             <span class="keywordflow">return</span> _mm_loadu_ps(p);
<a name="l00399"></a>00399         }
<a name="l00400"></a>00400         <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <span class="keywordtype">void</span> store(<span class="keywordtype">float</span> *p, <span class="keyword">const</span> __m128&amp; v)
<a name="l00401"></a>00401         {
<a name="l00402"></a>00402             _mm_storeu_ps(p, v);
<a name="l00403"></a>00403         }
<a name="l00404"></a>00404     };
<a name="l00405"></a>00405     <span class="comment">// Special aligned accessor</span>
<a name="l00406"></a>00406     <span class="keyword">template</span> &lt;&gt;
<a name="l00407"></a>00407     <span class="keyword">struct </span>SSEMemoryAccessor&lt;true&gt;
<a name="l00408"></a>00408     {
<a name="l00409"></a>00409         <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <span class="keyword">const</span> __m128&amp; load(<span class="keyword">const</span> <span class="keywordtype">float</span> *p)
<a name="l00410"></a>00410         {
<a name="l00411"></a>00411             <span class="keywordflow">return</span> __MM_LOAD_PS(p);
<a name="l00412"></a>00412         }
<a name="l00413"></a>00413         <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <span class="keywordtype">void</span> store(<span class="keywordtype">float</span> *p, <span class="keyword">const</span> __m128&amp; v)
<a name="l00414"></a>00414         {
<a name="l00415"></a>00415             __MM_STORE_PS(p, v);
<a name="l00416"></a>00416         }
<a name="l00417"></a>00417     };
<a name="l00418"></a>00418 
<a name="l00421"></a>00421     <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <span class="keywordtype">bool</span> _isAlignedForSSE(<span class="keyword">const</span> <span class="keywordtype">void</span> *p)
<a name="l00422"></a>00422     {
<a name="l00423"></a>00423         <span class="keywordflow">return</span> (((<span class="keywordtype">size_t</span>)p) &amp; 15) == 0;
<a name="l00424"></a>00424     }
<a name="l00425"></a>00425 
<a name="l00429"></a>00429     <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> __m128 __mm_rsqrt_nr_ps(<span class="keyword">const</span> __m128&amp; x)
<a name="l00430"></a>00430     {
<a name="l00431"></a>00431         <span class="keyword">static</span> <span class="keyword">const</span> __m128 v0pt5 = { 0.5f, 0.5f, 0.5f, 0.5f };
<a name="l00432"></a>00432         <span class="keyword">static</span> <span class="keyword">const</span> __m128 v3pt0 = { 3.0f, 3.0f, 3.0f, 3.0f };
<a name="l00433"></a>00433         __m128 t = _mm_rsqrt_ps(x);
<a name="l00434"></a>00434         <span class="keywordflow">return</span> _mm_mul_ps(_mm_mul_ps(v0pt5, t),
<a name="l00435"></a>00435             _mm_sub_ps(v3pt0, _mm_mul_ps(_mm_mul_ps(x, t), t)));
<a name="l00436"></a>00436     }
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 <span class="comment">// Macro to check the stack aligned for SSE</span>
<a name="l00439"></a>00439 <span class="preprocessor">#if OGRE_DEBUG_MODE</span>
<a name="l00440"></a>00440 <span class="preprocessor"></span><span class="preprocessor">#define __OGRE_CHECK_STACK_ALIGNED_FOR_SSE()        \</span>
<a name="l00441"></a>00441 <span class="preprocessor">    {                                               \</span>
<a name="l00442"></a>00442 <span class="preprocessor">        __m128 test;                                \</span>
<a name="l00443"></a>00443 <span class="preprocessor">        assert(_isAlignedForSSE(&amp;test));            \</span>
<a name="l00444"></a>00444 <span class="preprocessor">    }</span>
<a name="l00445"></a>00445 <span class="preprocessor"></span>
<a name="l00446"></a>00446 <span class="preprocessor">#else   // !OGRE_DEBUG_MODE</span>
<a name="l00447"></a>00447 <span class="preprocessor"></span><span class="preprocessor">#define __OGRE_CHECK_STACK_ALIGNED_FOR_SSE()</span>
<a name="l00448"></a>00448 <span class="preprocessor"></span>
<a name="l00449"></a>00449 <span class="preprocessor">#endif  // OGRE_DEBUG_MODE</span>
<a name="l00450"></a>00450 <span class="preprocessor"></span>
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 <span class="preprocessor">#endif  // __OGRE_HAVE_SSE</span>
<a name="l00453"></a>00453 <span class="preprocessor"></span>
<a name="l00454"></a>00454 }
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 <span class="preprocessor">#endif // __SIMDHelper_H__</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
